#include <bits/stdc++.h>

using namespace std;

int ans = 0;
int comp = 0;

void dfs1(int start, vector <vector <int> > v, vector <int> &used){
    stack <int> st;
    st.push(start);
    while(!st.empty()){
        int g = st.top();
        used[g] = 1;
        st.pop();
        for(int i = 0; i < v[g].size(); i++){
            if(!used[v[g][i]]){
                st.push(v[g][i]);
            }
        }
    }
}

void dfs2(int start, vector <vector <int> > v, vector <int> &used1, vector <int> &color){
    int len=0;
    stack <int> st;
    st.push(start);
    while(!st.empty()){
        int g = st.top();
        used1[g] = 1;
        st.pop();
        for(int i = 0; i < v[g].size(); i++){
            if(!used1[v[g][i]]){
                st.push(v[g][i]);
                len++;
            }
            if(v[g][i]==start and len > 2){
                ans++;
                color[v[g][i]]=0;
                return;
            }
        }
    }
}

int main(){
    int n;
    cin>>n;
    vector <int> mas(n);
    for(int i = 0; i < n; i++){
        int now;
        cin>>now;
        mas[i]=now-1;
    }
    vector <vector <int> > v(n, vector <int>());
    vector <int> used(n, 0);
    for(int i = 0; i < n; i++){
        v[i].push_back(mas[i]);
        v[mas[i]].push_back(i);
    }
    for(int i = 0; i < n; i++){
        if(v[i][0]==v[i][1]){
            v[i].pop_back();
        }
    }
    vector <int> color(n, -5);
    for(int i = 0; i < n; i++){
        if(!used[i]){
            dfs1(i, v, used);
            comp++;
        }
    }
    vector <int> used1(n, 0);
    int w = 1;
    for(int i = 0; i < n; i++){
        if(w==comp){
                break;
            }
        if(!used1[i]){
            dfs2(i, v, used1, color);
            w++;
        }
    }
    for(int i = 0; i < n; i++){
        if(color[i]==-5){
            color[i]=1;
            if(color[mas[i]]==0){
                continue;
            }
            else{
                color[mas[i]]=-1;
            }
        }
    }
    cout<<ans<<endl;
    for(int i = 0; i < n; i++){
        if(color[i]==-1){
            cout<<i+1<<" ";
        }
    }
    cout<<endl;
    for(int i =0; i < n;i++){
        if(color[i]==1){
            cout<<i+1<<" ";
        }
    }
    return 0;
}